package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.model.platform.CommonTreeModel;
import cn.estsh.i3plus.pojo.platform.bean.SysDepartment;
import cn.estsh.i3plus.pojo.platform.bean.SysMenu;
import cn.estsh.i3plus.pojo.platform.bean.SysOrganize;
import cn.estsh.i3plus.pojo.platform.bean.SysPosition;

import java.util.List;

/**
 * @Description : 通用树查询服务
 * @Reference :
 * @Author : wei.peng
 * @Date : 2018-10-24 11:16
 * @Modify :
 **/
public interface ICoreTreeService {

    /**
     * 获取岗位树
     * @param parentId
     * @return
     */
    List<SysPosition> findSysPositionTreeByParentId(long parentId);

    /**
     * 获取岗位树
     * @param id
     * @return
     */
    SysPosition getSysPositionTreeById(long id);

    /**
     * 生成子集树递归方法
     * @param parent 父类对象
     * @param step 层级
     */
    void findSysPositionChildrenTreePack(SysPosition parent,int step);

    /**
     * 检查父节点是否是子节点ID或者为当前节点ID
     * @param position
     */
    void doValidatorSysPositionParentId(SysPosition position) ;

    /**
     * 获取部门树
     * @param parentId
     * @return
     */
    List<SysDepartment> findSysDepartmentTreeByParentId(long parentId);

    /**
     * 获取部门树
     * @param id
     * @return
     */
    SysDepartment getSysDepartmentTreeById(long id);

    /**
     * 生成子集树递归方法
     * @param parent 父类对象
     * @param step 层级
     */
    void findSysDepartmentChildrenTreePack(SysDepartment parent,int step);

    /**
     * 检查父节点是否是子节点ID或者为当前节点ID
     * @param department
     */
    void doValidatorSysDepartmentParentId(SysDepartment department) ;

    /**
     * 获取组织树
     * @param parentId
     * @return
     */
    List<SysOrganize> findSysOrganizeTreeByParentId(long parentId);

    /**
     * 获取组织树
     * @param id
     * @return
     */
    SysOrganize getSysOrganizeTreeById(long id);

    /**
     * 生成子集树递归方法
     * @param parent 父类对象
     * @param step 层级
     */
    void findSysOrganizeChildrenTreePack(SysOrganize parent,int step);

    /**
     * 检查父节点是否是子节点ID或者为当前节点ID
     * @param organize
     */
    void doValidatorSysOrganizeParentId(SysOrganize organize) ;

    /**
     * 获取组织树
     * @param parentId
     * @return
     */
    List<SysMenu> findSysMenuTreeByParentId(long parentId);

    /**
     * 获取组织树
     * @param id
     * @return
     */
    SysMenu getSysMenuTreeById(long id);

    /**
     * 生成子集树递归方法
     * @param parent 父类对象
     * @param step 层级
     */
    void findSysMenuChildrenTreePack(SysMenu parent, int step);

    /**
     * 检查父节点是否是子节点ID或者为当前节点ID
     * @param menu
     */
    void doValidatorSysMenuParentId(SysMenu menu) ;

    /**
     * 获取组织树
     * @param parentId
     * @return
     */
    List<CommonTreeModel> findOrganizeDepartment(long parentId);

    /**
     * 获取组织树
     * @param id
     * @return
     */
    CommonTreeModel getOrganizeById(long id);

    /**
     * 生成子集树递归方法
     * @param parent 父类对象
     * @param step 层级
     */
    void findOrganizeTreePack(CommonTreeModel parent, int step);

}
