package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.SysTaskTime;
import cn.estsh.i3plus.pojo.platform.bean.SysTaskTimeExpression;

import java.util.List;

/**
 * @Description : 定时任务业务接口
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.968
 * @Modify      :
 **/
public interface ISysTaskTimeService {

    /**
     *  新增数据
     * @param taskTime
     * @return
     */
    SysTaskTime insertSysTaskTime(SysTaskTime taskTime, SysTaskTimeExpression taskTimeExpression);

    /**
     * 修改数据
     * @param taskTime
     */
    void updateSysTaskTime(SysTaskTime taskTime, SysTaskTimeExpression taskTimeExpression);

    /**
     * 修改任务状态
     * @param id        任务ID
     * @param status    任务状态
     * @param user      当前会话用户
     */
    void updateSysTaskTimeStatus(Long id, int status, SessionUser user);

    /**
     * 根据Key 删除数据
     * @param id
     */
    void deleteSysTaskTimeById(Long id);

    /**
     * 查询所有数据
     * @return
     */
    List<SysTaskTime> listSysTaskTime();

    /**
     * 根据id 数据
     * @param id
     * @return
     */
    SysTaskTime getSysTaskTimeById(Long id);

    /**
     * 定时任务复制查询，分页，排序
     * @param taskTime
     * @param pager
     * @return
     */
    ListPager querySysTaskTimeByPager(SysTaskTime taskTime, Pager pager);

    /**
     * 根据id批量删除定时任务
     * @param ids
     */
    void deleteSysTaskTimeByIds(Long[] ids);

    /**
     * 批量修改定时任务状态
     * @param ids
     *
     */
    void updateSysTaskTimeStatusByIds(Long[] ids, Integer status);

    /**
     * 修改最后时间
     * @param lastDate
     * @param name
     * @param groupName
     */
    void doSysTaskTimeLastDateByNameAndGroupName(String lastDate,String name,String groupName);

    /**
     * 立即执行
     * @param id
     */
    void executeSysTaskTimeById(Long id);
}
