package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SysTool;
import cn.estsh.i3plus.pojo.platform.bean.SysToolType;

import java.util.List;

/**
 * @Description : 硬件服务接口
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-25 20:20
 * @Modify :
 **/
public interface ISysToolService {

    /**
     * 添加硬件
     * @param tool
     */
    SysTool insertSysTool(SysTool tool);

    /**
     * 删除硬件
     * @param id
     */
    void deleteSysToolById(Long id);

    /**
     * 修改硬件
     * @param tool
     */
    void updateSysTool(SysTool tool);

    /**
     * 查找全部硬件
     * @return
     */
    List<SysTool> listSysTool();

    /**
     * 根据id查找硬件
     * @param id
     * @return
     */
    SysTool getSysToolById(Long id);

    /**
     * 硬件复杂查询，分页，排序
     * @param tool
     * @param pager
     * @return
     */
    ListPager querySysToolByPager(SysTool tool, Pager pager);

    /**
     * 根据id修改硬件状态
     * @param id
     * @param status
     */
    void updateSysToolStatusById(Long id,Integer status);

    /**
     * 批量删除硬件
     * @param ids
     */
    void deleteSysToolByIds(Long[] ids);


    /**
     * 批量修改硬件状态
     * @param ids
     * @param status
     */
    void updateSysToolStatusByIds(Long[] ids,Integer status);
}
