package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ISysTaskTimeRecordingService;
import cn.estsh.i3plus.pojo.platform.bean.SysTaskTimeRecording;
import cn.estsh.i3plus.pojo.platform.repository.SysTaskTimeRecordingRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Description : 定时任务执行记录业务接口实现
 * @Reference :
 * @Author : wei.peng
 * @Date : 2018-10-22 16:58:44.011
 * @Modify :
 **/
@Service
public class SysTaskTimeRecordingService implements ISysTaskTimeRecordingService {

    public static final Logger LOGGER = LoggerFactory.getLogger(SysTaskTimeRecordingService.class);

    @Autowired
    private SysTaskTimeRecordingRepository taskTimeRecordingRDao;

    @Override
    public void updateSysTaskTimeRecording(SysTaskTimeRecording taskTimeRecording) {
        LOGGER.info("定时任务执行记录 TASK_TIMED_RECORDING :{}", taskTimeRecording);
        taskTimeRecordingRDao.update(taskTimeRecording);
    }

    @Override
    public void deleteSysTaskTimeRecordingById(Long id) {
        LOGGER.info("定时任务执行记录 TASK_TIMED_RECORDING Key:{}", id);
        taskTimeRecordingRDao.deleteById(id);
    }

    @Override
    public SysTaskTimeRecording insertSysTaskTimeRecording(SysTaskTimeRecording taskTimeRecording) {
        LOGGER.info("定时任务执行记录 TASK_TIMED_RECORDING :{}", taskTimeRecording);
        return taskTimeRecordingRDao.insert(taskTimeRecording);
    }

    @Override
    public List<SysTaskTimeRecording> findSysTaskTimeRecordingAll() {
        LOGGER.info("定时任务执行记录 TASK_TIMED_RECORDING find All");
        return taskTimeRecordingRDao.findAll();
    }

    @Override
    public SysTaskTimeRecording getSysTaskTimeRecordingById(Long id) {
        LOGGER.info("定时任务执行记录 TASK_TIMED_RECORDING find id:{}", id);
        return taskTimeRecordingRDao.getOne(id);
    }
}
